/* df3tcl.h */

#ifndef DF3TCL_H

#define DF3TCL_H 202005L

/* cf PATH_MAX */
#define _POSIX_C_SOURCE 200809L

#include <df3.h>
#include <errno.h>
#include <limits.h>
#include <string.h>
#include <tcl.h>
#include <unistd.h>


/* a volume */
typedef struct Volume Volume;
struct Volume {
  df3Handle df3;
  size_t id;
  unsigned int lv;
};


/* "state" */
typedef struct Df3tclData Df3tclData;
struct Df3tclData {
  bool writemode;
  char *workdir;
  size_t nextid;
  Tcl_HashTable hash;
  Tcl_Interp *interp;
};


/* main.c */
void appTclPanic(char const * const, int const) __attribute__((noreturn));
void appPanic(char const * const, int const) __attribute__((noreturn));
char *storeFname(char const * const, char const * const, bool *);

extern bool app_diag;
extern char const * const app_name;
extern char const * const app_version;


/* tclif.c */
void prepTclif(Df3tclData *, Tcl_Interp *, char **);


/* conveniences */
#define CHRDOT '.'
#define CHRNUL '\0'
#define CHRPTS '/'

#define FREENULL(p) do {free(p); (p) = NULL;} while (0)

#endif

